<!--
 * @Descripttion: (商品服务与承诺/tb_goods_services 编辑弹窗)
 * @version: (1.0)
 * @Author: (lwh)
 * @Date: (2023-06-18)
 * @LastEditors: (lwh)
 * @LastEditTime: (2023-06-18)
-->
<template>
  <el-dialog v-model="props.modelValue" title="修改商品服务与承诺信息" width="600px" @closed="closeDialog" @open="openDialog">
    <el-form ref="formRef" :model="formData" :rules="rules">
      
      <el-row :gutter="20" v-if="userid == 1">
        <el-col :lg="18">
          <el-form-item :label-width="labelWidth" label="店铺">
            <el-input v-model='formData.shopName' disabled type="text">
            </el-input>
          </el-form-item>
        </el-col>
      </el-row>

      <el-row :gutter="20">

        <el-col :lg="24">
          <el-form-item :label-width="labelWidth" label="服务名称" prop="goodsServicesName">
            <el-input v-model="formData.goodsServicesName" placeholder="请输入服务名称" />
          </el-form-item>
        </el-col>
        <el-col :lg="24">
          <el-form-item :label-width="labelWidth" label="概述" prop="goodsServicesSummary">
            <el-input v-model="formData.goodsServicesSummary" type="textarea" :rows="5" placeholder="请输入概述" />
          </el-form-item>
        </el-col>
        <el-col :lg="12">
          <el-form-item :label-width="labelWidth" label="是否默认" prop="goodsServicesIsDefault">
            <el-radio-group v-model="formData.goodsServicesIsDefault">
              <el-radio v-for="item in  is_default " :key="item.dictValue" :label="parseInt(item.dictValue)">{{
                item.dictLabel }}</el-radio>
            </el-radio-group>
          </el-form-item>
        </el-col>
        <el-col :lg="24">
          <el-form-item :label-width="labelWidth" label="显示状态" prop="goodsServicesDisplayStatus">
            <el-radio-group v-model="formData.goodsServicesDisplayStatus">
              <el-radio v-for="item in  display_status " :key="item.dictValue" :label="parseInt(item.dictValue)">{{
                item.dictLabel }}</el-radio>
            </el-radio-group>
          </el-form-item>
        </el-col>
        <el-col :lg="24">
          <el-form-item :label-width="labelWidth" label="排序" prop="goodsServicesSort">
            <el-input-number v-model.number="formData.goodsServicesSort" controls-position="right" :min="0" />
          </el-form-item>
        </el-col>

      </el-row>
    </el-form>

    <template #footer>
      <div class="dialog-footer">
        <el-button type="primary" @click="handleEditClick(formRef)">编辑</el-button>
        <el-button @click="handleResetClick(formRef)">重置</el-button>
      </div>
    </template>
  </el-dialog>
</template>

<script setup>
import { ElMessage } from 'element-plus'
import modal from '@/plugins/modal.js'
import { reactive, ref, watch } from "vue";
import { addOrUpdateGoodsServices } from "@/api/business/GoodsManager/GoodsServicess/goodsServices.js";
import useUserStore from '@/store/modules/user'

// 打开弹窗时回调
const openDialog = async () => {
  await getis_default()
  await getdisplay_status()

}

const formData = ref({
  ...props.data,
});
watch(props, async (v) => {
  formData.value = v.data;

});

// 业务参数
// 是否默认字典选项列表
const is_default = ref([]);
// 显示状态字典选项列表
const display_status = ref([]);

const userid = useUserStore().userId


// -业务方法
//字典获取
async function getis_default() {
  await proxy.getDicts('is_default').then((res) => {
    is_default.value = res.data
  })
}
//字典获取
async function getdisplay_status() {
  await proxy.getDicts('display_status').then((res) => {
    display_status.value = res.data
  })
}


// -基础参数
const props = defineProps({
  modelValue: Boolean,
  data: Object,
  done: Function,
});

const labelWidth = 100;
const formRef = ref();
const { proxy } = getCurrentInstance()
const emits = defineEmits(["update:modelValue"]);
const imgData = ref({
  fileDir: "GoodsServices"
})

// 验证
const rules = reactive({
  goodsServicesName: [{ required: true, message: "服务名称不能为空", trigger: "blur" }],
  goodsServicesIsDefault: [{ required: true, message: "是否默认不能为空", trigger: "blur", type: "number" }],
  goodsServicesDisplayStatus: [{ required: true, message: "显示状态不能为空", trigger: "blur", type: "number" }],
  goodsServicesSort: [{ required: true, message: "排序不能为空", trigger: "blur", type: "number" }],
});

// -基础方法
// 提交
const handleEditClick = async (formEl) => {
  if (!formEl) return;
  formEl.validate(async (valid) => {
    if (!valid) {
      return;
    }


    const { code } = await addOrUpdateGoodsServices(formData.value);
    if (code == 200) {
      modal.msgSuccess('修改成功')
      closeDialog();
    }
  });
}

const handleResetClick = async (formEl) => {
  if (!formEl) return;
  formEl.resetFields();
}
const closeDialog = () => {
  props.done();
  emits("update:modelValue", false);
};

</script>
